// src/styles/form-control.styles.ts
import { css } from "lit";
var form_control_styles_default = css`
  .form-control .form-control__label {
    display: none;
  }

  .form-control .form-control__help-text {
    display: none;
  }

  /* Label */
  .form-control--has-label .form-control__label {
    display: inline-block;
    color: var(--p-input-label-color);
    margin-bottom: var(--p-spacing-3x-small);
    font-weight: var(--p-font-weight-medium);
  }

  .form-control--has-label.form-control--small .form-control__label {
    font-size: var(--p-input-label-font-size-small);
  }

  .form-control--has-label.form-control--medium .form-control__label {
    font-size: var(--p-input-label-font-size-medium);
  }

  .form-control--has-label.form-control--large .form-control__label {
    font-size: var(--p-input-label-font-size-large);
  }

  :host([required]) .form-control--has-label .form-control__label::after {
    content: var(--p-input-required-content);
    margin-inline-start: var(--p-input-required-content-offset);
    color: var(--p-input-required-content-color);
  }

  /* Help text */
  .form-control--has-help-text .form-control__help-text {
    display: block;
    color: var(--p-input-help-text-color);
    margin-top: var(--p-spacing-3x-small);
  }

  .form-control--has-help-text.form-control--small .form-control__help-text {
    font-size: var(--p-input-help-text-font-size-small);
  }

  .form-control--has-help-text.form-control--medium .form-control__help-text {
    font-size: var(--p-input-help-text-font-size-medium);
  }

  .form-control--has-help-text.form-control--large .form-control__help-text {
    font-size: var(--p-input-help-text-font-size-large);
  }

  .form-control--has-help-text.form-control--radio-group .form-control__help-text {
    margin-top: var(--p-spacing-2x-small);
  }
`;

export {
  form_control_styles_default
};
